/* Intel P6 gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 1999, 2000, 2001, 2002 Free Software Foundation,
Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the GNU MP Library; see the file COPYING.LIB.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA. */


#define BITS_PER_MP_LIMB 32
#define BYTES_PER_MP_LIMB 4


/* 800MHz P-III, gcc 2.95.2 (and 200MHz P6 with gcc 2.7.2.3 is similar) */

/* Generated by tuneup.c, 2001-11-28, gcc 2.95 */

#define MUL_KARATSUBA_THRESHOLD       23
#define MUL_TOOM3_THRESHOLD          164

#define SQR_BASECASE_THRESHOLD         0
#define SQR_KARATSUBA_THRESHOLD       50
#define SQR_TOOM3_THRESHOLD          202

#define DIV_SB_PREINV_THRESHOLD            4
#define DIV_DC_THRESHOLD                 111
#define POWM_THRESHOLD               142

#define GCD_ACCEL_THRESHOLD            3
#define GCDEXT_THRESHOLD              45

#define USE_PREINV_MOD_1               1  /* (native) */
#define DIVREM_2_THRESHOLD             0
#define DIVEXACT_1_THRESHOLD           0
#define MODEXACT_1_ODD_THRESHOLD       0

#define MUL_FFT_TABLE  { 592, 1440, 2688, 5632, 14336, 40960, 0 }
#define MUL_FFT_MODF_THRESHOLD       608
#define MUL_FFT_THRESHOLD           5376

#define SQR_FFT_TABLE  { 656, 1504, 2944, 6656, 18432, 57344, 0 }
#define SQR_FFT_MODF_THRESHOLD       672
#define SQR_FFT_THRESHOLD           5376
